const char * neighbor_gpu = 

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_pre_cuda_hip.h\"\n"
"#define ucl_pow pow\n"
"#endif\n"
"#if !defined(NV_KERNEL) && !defined(USE_HIP)\n"
"#define USE_OPENCL\n"
"#if (__OPENCL_VERSION__ > 199)\n"
"#define NOUNROLL __attribute__((opencl_unroll_hint(1)))\n"
"#else\n"
"#define NOUNROLL\n"
"#endif\n"
"#define GLOBAL_ID_X get_global_id(0)\n"
"#define THREAD_ID_X get_local_id(0)\n"
"#define BLOCK_ID_X get_group_id(0)\n"
"#define BLOCK_SIZE_X get_local_size(0)\n"
"#define GLOBAL_SIZE_X get_global_size(0)\n"
"#define THREAD_ID_Y get_local_id(1)\n"
"#define BLOCK_ID_Y get_group_id(1)\n"
"#define NUM_BLOCKS_X get_num_groups(0)\n"
"#define __syncthreads() barrier(CLK_LOCAL_MEM_FENCE)\n"
"#define ucl_inline inline\n"
"#define fetch4(ans,i,x) ans=x[i]\n"
"#define fetch(ans,i,q) ans=q[i]\n"
"#ifndef _SINGLE_SINGLE\n"
"#ifndef cl_khr_fp64\n"
"#ifndef cl_amd_fp64\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#if defined(cl_khr_fp64)\n"
"#pragma OPENCL EXTENSION cl_khr_fp64 : enable\n"
"#elif defined(cl_amd_fp64)\n"
"#pragma OPENCL EXTENSION cl_amd_fp64 : enable\n"
"#endif\n"
"#endif\n"
"#define fast_mul(X,Y) (X)*(Y)\n"
"#define ucl_atan atan\n"
"#define ucl_cbrt cbrt\n"
"#define ucl_ceil ceil\n"
"#define ucl_abs fabs\n"
"#if defined(FAST_MATH) && !defined(_DOUBLE_DOUBLE)\n"
"#define ucl_exp native_exp\n"
"#define ucl_pow pow\n"
"#define ucl_powr native_powr\n"
"#define ucl_rsqrt native_rsqrt\n"
"#define ucl_sqrt native_sqrt\n"
"#define ucl_recip native_recip\n"
"#else\n"
"#define ucl_exp exp\n"
"#define ucl_pow pow\n"
"#define ucl_powr powr\n"
"#define ucl_rsqrt rsqrt\n"
"#define ucl_sqrt sqrt\n"
"#define ucl_recip(x) ((numtyp)1.0/(x))\n"
"#endif\n"
"#if (SHUFFLE_AVAIL == 1)\n"
"  #ifdef cl_intel_subgroups\n"
"    #pragma OPENCL EXTENSION cl_intel_subgroups : enable\n"
"    #define shfl_down(var, delta, width) \\\n"
"      intel_sub_group_shuffle_down(var, var, delta)\n"
"    #define shfl_xor(var, lanemask, width) \\\n"
"      intel_sub_group_shuffle_xor(var, lanemask)\n"
"    #define simd_broadcast_i(var, src, width) sub_group_broadcast(var, src)\n"
"    #define simd_broadcast_f(var, src, width) sub_group_broadcast(var, src)\n"
"    #define simd_broadcast_d(var, src, width) sub_group_broadcast(var, src)\n"
"  #else\n"
"    #ifdef _SINGLE_SINGLE\n"
"      inline float shfl_down(float var, unsigned int delta, int width) {\n"
"        float ret;\n"
"        int c;\n"
"        c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"        asm volatile (\"shfl.sync.down.b32 %0, %1, %2, %3, %4;\" : \"=f\"(ret) : \"f\"(var), \"r\"(delta), \"r\"(c), \"r\"(0xffffffff));\n"
"        return ret;\n"
"      }\n"
"      inline float shfl_xor(float var, unsigned int lanemask, int width) {\n"
"        float ret;\n"
"        int c;\n"
"        c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"        asm volatile (\"shfl.sync.bfly.b32 %0, %1, %2, %3, %4;\" : \"=f\"(ret) : \"f\"(var), \"r\"(lanemask), \"r\"(c), \"r\"(0xffffffff));\n"
"        return ret;\n"
"      }\n"
"    #else\n"
"      inline double shfl_down(double var, unsigned int delta, int width) {\n"
"        int c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"        int x,y,x2,y2;\n"
"        double ans;\n"
"        asm volatile (\"mov.b64 {%0, %1}, %2;\" : \"=r\"(y), \"=r\"(x) : \"d\"(var));\n"
"        asm volatile (\"shfl.sync.down.b32 %0, %1, %2, %3, %4;\" : \"=r\"(x2) : \"r\"(x), \"r\"(delta), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"shfl.sync.down.b32 %0, %1, %2, %3, %4;\" : \"=r\"(y2) : \"r\"(y), \"r\"(delta), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"mov.b64 %0, {%1, %2};\" : \"=d\"(ans) : \"r\"(y2), \"r\"(x2));\n"
"        return ans;\n"
"      }\n"
"      inline double shfl_xor(double var, unsigned int lanemask, int width) {\n"
"        int c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"        int x,y,x2,y2;\n"
"        double ans;\n"
"        asm volatile (\"mov.b64 {%0, %1}, %2;\" : \"=r\"(y), \"=r\"(x) : \"d\"(var));\n"
"        asm volatile (\"shfl.sync.bfly.b32 %0, %1, %2, %3, %4;\" : \"=r\"(x2) : \"r\"(x), \"r\"(lanemask), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"shfl.sync.bfly.b32 %0, %1, %2, %3, %4;\" : \"=r\"(y2) : \"r\"(y), \"r\"(lanemask), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"mov.b64 %0, {%1, %2};\" : \"=d\"(ans) : \"r\"(y2), \"r\"(x2));\n"
"        return ans;\n"
"      }\n"
"    #endif\n"
"    inline int simd_broadcast_i(int var, unsigned int src, int width) {\n"
"      int ret;\n"
"      int c;\n"
"      c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"      asm volatile (\"shfl.sync.idx.b32 %0, %1, %2, %3, %4;\" : \"=f\"(ret) : \"f\"(var), \"r\"(src), \"r\"(c), \"r\"(0xffffffff));\n"
"      return ret;\n"
"    }\n"
"    inline float simd_broadcast_f(float var, unsigned int src, int width) {\n"
"      float ret;\n"
"      int c;\n"
"      c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"      asm volatile (\"shfl.sync.idx.b32 %0, %1, %2, %3, %4;\" : \"=f\"(ret) : \"f\"(var), \"r\"(src), \"r\"(c), \"r\"(0xffffffff));\n"
"      return ret;\n"
"    }\n"
"    #ifdef _DOUBLE_DOUBLE\n"
"      inline double simd_broadcast_d(double var, unsigned int src, int width) {\n"
"        int c = ((SIMD_SIZE-width) << 8) | 0x1f;\n"
"        int x,y,x2,y2;\n"
"        double ans;\n"
"        asm volatile (\"mov.b64 {%0, %1}, %2;\" : \"=r\"(y), \"=r\"(x) : \"d\"(var));\n"
"        asm volatile (\"shfl.sync.idx.b32 %0, %1, %2, %3, %4;\" : \"=r\"(x2) : \"r\"(x), \"r\"(src), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"shfl.sync.idx.b32 %0, %1, %2, %3, %4;\" : \"=r\"(y2) : \"r\"(y), \"r\"(src), \"r\"(c), \"r\"(0xffffffff));\n"
"        asm volatile (\"mov.b64 %0, {%1, %2};\" : \"=d\"(ans) : \"r\"(y2), \"r\"(x2));\n"
"        return ans;\n"
"      }\n"
"    #endif\n"
"  #endif\n"
"#endif\n"
"#ifdef USE_OPENCL_SUBGROUPS\n"
"  #ifndef cl_intel_subgroups\n"
"    #pragma OPENCL EXTENSION cl_khr_subgroups : enable\n"
"  #endif\n"
"  #define simdsync() sub_group_barrier(CLK_LOCAL_MEM_FENCE)\n"
"  #define simd_size() get_max_sub_group_size()\n"
"#else\n"
"  #define simdsync()\n"
"  #define simd_size() SIMD_SIZE\n"
"#endif\n"
"#endif\n"
"#ifdef _DOUBLE_DOUBLE\n"
"#define numtyp double\n"
"#define numtyp2 double2\n"
"#define numtyp4 double4\n"
"#define acctyp double\n"
"#define acctyp2 double2\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifdef _SINGLE_DOUBLE\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp double\n"
"#define acctyp2 double2\n"
"#define acctyp4 double4\n"
"#endif\n"
"#ifndef numtyp\n"
"#define numtyp float\n"
"#define numtyp2 float2\n"
"#define numtyp4 float4\n"
"#define acctyp float\n"
"#define acctyp2 float2\n"
"#define acctyp4 float4\n"
"#endif\n"
"#define EWALD_F (numtyp)1.12837917\n"
"#define EWALD_P (numtyp)0.3275911\n"
"#define A1 (numtyp)0.254829592\n"
"#define A2 (numtyp)-0.284496736\n"
"#define A3 (numtyp)1.421413741\n"
"#define A4 (numtyp)-1.453152027\n"
"#define A5 (numtyp)1.061405429\n"
"#define SBBITS 30\n"
"#define NEIGHMASK 0x3FFFFFFF\n"
"ucl_inline int sbmask(int j) { return j >> SBBITS & 3; };\n"
"#if !defined(LAMMPS_SMALLSMALL) && !defined(LAMMPS_BIGBIG) && \\\n"
"    !defined(LAMMPS_SMALLBIG)\n"
"#define LAMMPS_SMALLBIG\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_preprocessor.h\"\n"
"#endif\n"
"#define atom_info(t_per_atom, ii, tid, offset)                               \\\n"
"  tid=THREAD_ID_X;                                                           \\\n"
"  offset=tid & (t_per_atom-1);                                               \\\n"
"  ii=fast_mul((int)BLOCK_ID_X,(int)(BLOCK_SIZE_X)/t_per_atom)+tid/t_per_atom;\n"
"#define nbor_info(dev_nbor, dev_packed, nbor_pitch, t_per_atom, ii, offset,  \\\n"
"                  i, numj, n_stride, nbor_end, nbor_begin)                   \\\n"
"  i=dev_nbor[ii];                                                            \\\n"
"  nbor_begin=ii+nbor_pitch;                                                  \\\n"
"  numj=dev_nbor[nbor_begin];                                                 \\\n"
"  if (dev_nbor==dev_packed) {                                                \\\n"
"    nbor_begin+=nbor_pitch+fast_mul(ii,t_per_atom-1);                        \\\n"
"    n_stride=fast_mul(t_per_atom,nbor_pitch);                                \\\n"
"    nbor_end=nbor_begin+fast_mul(numj/t_per_atom,n_stride)+(numj & (t_per_atom-1)); \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  } else {                                                                   \\\n"
"    nbor_begin+=nbor_pitch;                                                  \\\n"
"    nbor_begin=dev_nbor[nbor_begin];                                         \\\n"
"    nbor_end=nbor_begin+numj;                                                \\\n"
"    n_stride=t_per_atom;                                                     \\\n"
"    nbor_begin+=offset;                                                      \\\n"
"  }\n"
"#define nbor_info_p(nbor_mem, nbor_stride, t_per_atom, ii, offset,           \\\n"
"                    i, numj, stride, nbor_end, nbor_begin)                   \\\n"
"    i=nbor_mem[ii];                                                          \\\n"
"    nbor_begin=ii+nbor_stride;                                               \\\n"
"    numj=nbor_mem[nbor_begin];                                               \\\n"
"    nbor_begin+=nbor_stride+ii*(t_per_atom-1);                               \\\n"
"    stride=fast_mul(t_per_atom,nbor_stride);                                 \\\n"
"    nbor_end=nbor_begin+fast_mul(numj/t_per_atom,stride)+(numj &             \\\n"
"                                                          (t_per_atom-1));   \\\n"
"    nbor_begin+=offset;\n"
"#if (SHUFFLE_AVAIL == 0)\n"
"#define simd_reduce_add1(width, local, offset, tid, one)                    \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    simdsync();                                                             \\\n"
"    if (offset < s) local[0][tid] += local[0][tid+s];                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) one=local[0][tid];\n"
"#define simd_reduce_add2(width, local, offset, tid, one, two)               \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  local[1][tid]=two;                                                        \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    simdsync();                                                             \\\n"
"    if (offset < s) {                                                       \\\n"
"      local[0][tid] += local[0][tid+s];                                     \\\n"
"      local[1][tid] += local[1][tid+s];                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    one=local[0][tid];                                                      \\\n"
"    two=local[1][tid];                                                      \\\n"
"  }\n"
"#define simd_reduce_add3(width, local, offset, tid, one, two, three)        \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  local[1][tid]=two;                                                        \\\n"
"  local[2][tid]=three;                                                      \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    simdsync();                                                             \\\n"
"    if (offset < s) {                                                       \\\n"
"      local[0][tid] += local[0][tid+s];                                     \\\n"
"      local[1][tid] += local[1][tid+s];                                     \\\n"
"      local[2][tid] += local[2][tid+s];                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    one=local[0][tid];                                                      \\\n"
"    two=local[1][tid];                                                      \\\n"
"    three=local[2][tid];                                                    \\\n"
"  }\n"
"#define simd_reduce_add6(width, local, offset, tid, one, two, three,        \\\n"
"                         four, five, six)                                   \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  local[1][tid]=two;                                                        \\\n"
"  local[2][tid]=three;                                                      \\\n"
"  local[3][tid]=four;                                                       \\\n"
"  local[4][tid]=five;                                                       \\\n"
"  local[5][tid]=six;                                                        \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    simdsync();                                                             \\\n"
"    if (offset < s) {                                                       \\\n"
"      local[0][tid] += local[0][tid+s];                                     \\\n"
"      local[1][tid] += local[1][tid+s];                                     \\\n"
"      local[2][tid] += local[2][tid+s];                                     \\\n"
"      local[3][tid] += local[3][tid+s];                                     \\\n"
"      local[4][tid] += local[4][tid+s];                                     \\\n"
"      local[5][tid] += local[5][tid+s];                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    one=local[0][tid];                                                      \\\n"
"    two=local[1][tid];                                                      \\\n"
"    three=local[2][tid];                                                    \\\n"
"    four=local[3][tid];                                                     \\\n"
"    five=local[4][tid];                                                     \\\n"
"    six=local[5][tid];                                                      \\\n"
"  }\n"
"#define simd_reduce_arr(trip, width, local, offset, tid, arr)               \\\n"
"  for (int r=0; r<trip; r++)                                                \\\n"
"    local[r][tid]=arr[r];                                                   \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    simdsync();                                                             \\\n"
"    if (offset < s) {                                                       \\\n"
"      for (int r=0; r<trip; r++)                                            \\\n"
"        local[r][tid] += local[r][tid+s];                                   \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0) {                                                          \\\n"
"    for (int r=0; r<trip; r++)                                              \\\n"
"      arr[r]=local[r][tid];                                                 \\\n"
"  }\n"
"#define block_reduce_add1(width, local, tid, one)                           \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  for (unsigned int s=BLOCK_SIZE_X/2; s>width/2; s>>=1) {                   \\\n"
"    __syncthreads();                                                        \\\n"
"    if (tid < s) local[0][tid] += local[0][tid+s];                          \\\n"
"  }                                                                         \\\n"
"  if (tid<width) {                                                          \\\n"
"    for (unsigned int s=width/2; s>0; s>>=1) {                              \\\n"
"      simdsync();                                                           \\\n"
"      if (tid < s) local[0][tid] += local[0][tid+s];                        \\\n"
"    }                                                                       \\\n"
"    if (tid==0) one=local[0][tid];                                          \\\n"
"  }\n"
"#define block_reduce_add2(width, local, tid, one, two)                      \\\n"
"  local[0][tid]=one;                                                        \\\n"
"  local[1][tid]=two;                                                        \\\n"
"  for (unsigned int s=BLOCK_SIZE_X/2; s>width/2; s>>=1) {                   \\\n"
"    __syncthreads();                                                        \\\n"
"    if (tid < s) {                                                          \\\n"
"      local[0][tid] += local[0][tid+s];                                     \\\n"
"      local[1][tid] += local[1][tid+s];                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (tid<width) {                                                          \\\n"
"    for (unsigned int s=width/2; s>0; s>>=1) {                              \\\n"
"      simdsync();                                                           \\\n"
"      if (tid < s) {                                                        \\\n"
"        local[0][tid] += local[0][tid+s];                                   \\\n"
"        local[1][tid] += local[1][tid+s];                                   \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    if (tid==0) {                                                           \\\n"
"      one=local[0][tid];                                                    \\\n"
"      two=local[1][tid];                                                    \\\n"
"    }                                                                       \\\n"
"  }\n"
"#define block_reduce_arr(trip, width, local, tid, arr)                      \\\n"
"  for (int r=0; r<trip; r++)                                                \\\n"
"    local[r][tid]=arr[r];                                                   \\\n"
"  for (unsigned int s=BLOCK_SIZE_X/2; s>width/2; s>>=1) {                   \\\n"
"    __syncthreads();                                                        \\\n"
"    if (tid < s) {                                                          \\\n"
"      for (int r=0; r<trip; r++)                                            \\\n"
"        local[r][tid] += local[r][tid+s];                                   \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (tid<width) {                                                          \\\n"
"    for (unsigned int s=width/2; s>0; s>>=1) {                              \\\n"
"      simdsync();                                                           \\\n"
"      if (tid < s) {                                                        \\\n"
"        for (int r=0; r<trip; r++)                                          \\\n"
"          local[r][tid] += local[r][tid+s];                                 \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"    if (tid==0) {                                                           \\\n"
"      for (int r=0; r<trip; r++)                                            \\\n"
"        arr[r]=local[r][tid];                                               \\\n"
"    }                                                                       \\\n"
"  }\n"
"#define local_allocate_store_pair()                                         \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];\n"
"#define local_allocate_store_charge()                                       \\\n"
"    __local acctyp red_acc[6][BLOCK_PAIR];\n"
"#define local_allocate_store_bio()                                          \\\n"
"    __local acctyp red_acc[6][BLOCK_BIO_PAIR];\n"
"#define local_allocate_store_ellipse()                                      \\\n"
"    __local acctyp red_acc[6][BLOCK_ELLIPSE];\n"
"#define local_allocate_store_three()                                        \\\n"
"    __local acctyp red_acc[6][BLOCK_ELLIPSE];\n"
"#define store_answers(f, energy, virial, ii, inum, tid,                     \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    simd_reduce_add3(t_per_atom, red_acc, offset, tid, f.x, f.y, f.z);      \\\n"
"    if (EVFLAG && (vflag==2 || eflag==2)) {                                 \\\n"
"      if (eflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        simd_reduce_add1(t_per_atom, red_acc, offset, tid, energy);         \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        simd_reduce_arr(6, t_per_atom, red_acc, offset, tid, virial);       \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;                                      \\\n"
"  if (EVFLAG && (eflag || vflag)) {                                         \\\n"
"    int ei=BLOCK_ID_X;                                                      \\\n"
"    if (eflag!=2 && vflag!=2) {                                             \\\n"
"      const int ev_stride=NUM_BLOCKS_X;                                     \\\n"
"      if (eflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        block_reduce_add1(simd_size(), red_acc, tid, energy);               \\\n"
"        if (vflag) __syncthreads();                                         \\\n"
"        if (tid==0) {                                                       \\\n"
"          engv[ei]=energy*(acctyp)0.5;                                      \\\n"
"          ei+=ev_stride;                                                    \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        block_reduce_arr(6, simd_size(), red_acc, tid, virial);             \\\n"
"        if (tid==0) {                                                       \\\n"
"          for (int r=0; r<6; r++) {                                         \\\n"
"            engv[ei]=virial[r]*(acctyp)0.5;                                 \\\n"
"            ei+=ev_stride;                                                  \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    } else if (offset==0 && ii<inum) {                                      \\\n"
"      int ei=ii;                                                            \\\n"
"      if (EVFLAG && eflag) {                                                \\\n"
"        engv[ei]=energy*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"      if (EVFLAG && vflag) {                                                \\\n"
"        for (int i=0; i<6; i++) {                                           \\\n"
"          engv[ei]=virial[i]*(acctyp)0.5;                                   \\\n"
"          ei+=inum;                                                         \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    simd_reduce_add3(t_per_atom, red_acc, offset, tid, f.x, f.y, f.z);      \\\n"
"    if (EVFLAG && (vflag==2 || eflag==2)) {                                 \\\n"
"      if (eflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        simd_reduce_add2(t_per_atom, red_acc, offset, tid, energy, e_coul); \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        simd_reduce_arr(6, t_per_atom, red_acc, offset, tid, virial);       \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;                                      \\\n"
"  if (EVFLAG && (eflag || vflag)) {                                         \\\n"
"    int ei=BLOCK_ID_X;                                                      \\\n"
"    const int ev_stride=NUM_BLOCKS_X;                                       \\\n"
"    if (eflag!=2 && vflag!=2) {                                             \\\n"
"      if (eflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        block_reduce_add2(simd_size(), red_acc, tid, energy, e_coul);       \\\n"
"        if (vflag) __syncthreads();                                         \\\n"
"        if (tid==0) {                                                       \\\n"
"          engv[ei]=energy*(acctyp)0.5;                                      \\\n"
"          ei+=ev_stride;                                                    \\\n"
"          engv[ei]=e_coul*(acctyp)0.5;                                      \\\n"
"          ei+=ev_stride;                                                    \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        simdsync();                                                         \\\n"
"        block_reduce_arr(6, simd_size(), red_acc, tid, virial);             \\\n"
"        if (tid==0) {                                                       \\\n"
"          for (int r=0; r<6; r++) {                                         \\\n"
"            engv[ei]=virial[r]*(acctyp)0.5;                                 \\\n"
"            ei+=ev_stride;                                                  \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    } else if (offset==0 && ii<inum) {                                      \\\n"
"      int ei=ii;                                                            \\\n"
"      if (EVFLAG && eflag) {                                                \\\n"
"        engv[ei]=energy*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"        engv[ei]=e_coul*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"      if (EVFLAG && vflag) {                                                \\\n"
"        for (int i=0; i<6; i++) {                                           \\\n"
"          engv[ei]=virial[i]*(acctyp)0.5;                                   \\\n"
"          ei+=inum;                                                         \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }\n"
"#else\n"
"#define simd_reduce_add1(width, one)                                        \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) one += shfl_down(one, s, width);\n"
"#define simd_reduce_add2(width, one, two)                                   \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    one += shfl_down(one, s, width);                                        \\\n"
"    two += shfl_down(two, s, width);                                        \\\n"
"  }\n"
"#define simd_reduce_add3(width, one, two, three)                            \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    one += shfl_down(one, s, width);                                        \\\n"
"    two += shfl_down(two, s, width);                                        \\\n"
"    three += shfl_down(three, s, width);                                    \\\n"
"  }\n"
"#define simd_reduce_add6(width, one, two, three, four, five, six)           \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    one += shfl_down(one, s, width);                                        \\\n"
"    two += shfl_down(two, s, width);                                        \\\n"
"    three += shfl_down(three, s, width);                                    \\\n"
"    four += shfl_down(four, s, width);                                      \\\n"
"    five += shfl_down(five, s, width);                                      \\\n"
"    six += shfl_down(six, s, width);                                        \\\n"
"  }\n"
"#define simd_reduce_arr(trip, width, arr)                                   \\\n"
"  for (unsigned int s=width/2; s>0; s>>=1) {                                \\\n"
"    for (int r=0; r<trip; r++)                                              \\\n"
"      arr[r] += shfl_down(arr[r], s, width);                                \\\n"
"  }\n"
"#if (EVFLAG == 1)\n"
"#define local_allocate_store_pair()                                         \\\n"
"    __local acctyp red_acc[7][BLOCK_PAIR / SIMD_SIZE];\n"
"#define local_allocate_store_charge()                                       \\\n"
"    __local acctyp red_acc[8][BLOCK_PAIR / SIMD_SIZE];\n"
"#define local_allocate_store_bio()                                          \\\n"
"    __local acctyp red_acc[8][BLOCK_BIO_PAIR / SIMD_SIZE];\n"
"#define local_allocate_store_ellipse()\n"
"#define local_allocate_store_three()                                        \\\n"
"    __local acctyp red_acc[7][BLOCK_ELLIPSE / SIMD_SIZE];\n"
"#define store_answers(f, energy, virial, ii, inum, tid,                     \\\n"
"                      t_per_atom, offset, eflag, vflag, ans, engv)          \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    simd_reduce_add3(t_per_atom, f.x, f.y, f.z);                            \\\n"
"    if (vflag==2 || eflag==2) {                                             \\\n"
"      if (eflag)                                                            \\\n"
"        simd_reduce_add1(t_per_atom,energy);                                \\\n"
"      if (vflag)                                                            \\\n"
"        simd_reduce_arr(6, t_per_atom,virial);                              \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;                                      \\\n"
"  if (eflag || vflag) {                                                     \\\n"
"    if (eflag!=2 && vflag!=2) {                                             \\\n"
"      const int vwidth = simd_size();                                       \\\n"
"      const int voffset = tid & (simd_size() - 1);                          \\\n"
"      const int bnum = tid/simd_size();                                     \\\n"
"      int active_subgs = BLOCK_SIZE_X/simd_size();                          \\\n"
"      for ( ; active_subgs > 1; active_subgs /= vwidth) {                   \\\n"
"        if (active_subgs < BLOCK_SIZE_X/simd_size()) __syncthreads();       \\\n"
"        if (bnum < active_subgs) {                                          \\\n"
"          if (eflag) {                                                      \\\n"
"            simd_reduce_add1(vwidth, energy);                               \\\n"
"            if (voffset==0) red_acc[6][bnum] = energy;                      \\\n"
"          }                                                                 \\\n"
"          if (vflag) {                                                      \\\n"
"            simd_reduce_arr(6, vwidth, virial);                             \\\n"
"            if (voffset==0)                                                 \\\n"
"              for (int r=0; r<6; r++) red_acc[r][bnum]=virial[r];           \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"                                                                            \\\n"
"        __syncthreads();                                                    \\\n"
"        if (tid < active_subgs) {                                           \\\n"
"            if (eflag) energy = red_acc[6][tid];                            \\\n"
"          if (vflag)                                                        \\\n"
"            for (int r = 0; r < 6; r++) virial[r] = red_acc[r][tid];        \\\n"
"        } else {                                                            \\\n"
"          if (eflag) energy = (acctyp)0;                                    \\\n"
"          if (vflag) for (int r = 0; r < 6; r++) virial[r] = (acctyp)0;     \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"                                                                            \\\n"
"      if (bnum == 0) {                                                      \\\n"
"        int ei=BLOCK_ID_X;                                                  \\\n"
"        const int ev_stride=NUM_BLOCKS_X;                                   \\\n"
"        if (eflag) {                                                        \\\n"
"          simd_reduce_add1(vwidth, energy);                                 \\\n"
"          if (tid==0) {                                                     \\\n"
"            engv[ei]=energy*(acctyp)0.5;                                    \\\n"
"            ei+=ev_stride;                                                  \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"        if (vflag) {                                                        \\\n"
"          simd_reduce_arr(6, vwidth, virial);                               \\\n"
"          if (tid==0) {                                                     \\\n"
"            for (int r=0; r<6; r++) {                                       \\\n"
"              engv[ei]=virial[r]*(acctyp)0.5;                               \\\n"
"              ei+=ev_stride;                                                \\\n"
"            }                                                               \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    } else if (offset==0 && ii<inum) {                                      \\\n"
"      int ei=ii;                                                            \\\n"
"      if (eflag) {                                                          \\\n"
"        engv[ei]=energy*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        for (int i=0; i<6; i++) {                                           \\\n"
"          engv[ei]=virial[i]*(acctyp)0.5;                                   \\\n"
"          ei+=inum;                                                         \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1) {                                                       \\\n"
"    simd_reduce_add3(t_per_atom, f.x, f.y, f.z);                            \\\n"
"    if (vflag==2 || eflag==2) {                                             \\\n"
"      if (eflag)                                                            \\\n"
"        simd_reduce_add2(t_per_atom,energy,e_coul);                         \\\n"
"      if (vflag)                                                            \\\n"
"        simd_reduce_arr(6, t_per_atom,virial);                              \\\n"
"    }                                                                       \\\n"
"  }                                                                         \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;                                      \\\n"
"  if (eflag || vflag) {                                                     \\\n"
"    if (eflag!=2 && vflag!=2) {                                             \\\n"
"      const int vwidth = simd_size();                                       \\\n"
"      const int voffset = tid & (simd_size() - 1);                          \\\n"
"      const int bnum = tid/simd_size();                                     \\\n"
"      int active_subgs = BLOCK_SIZE_X/simd_size();                          \\\n"
"      for ( ; active_subgs > 1; active_subgs /= vwidth) {                   \\\n"
"        if (active_subgs < BLOCK_SIZE_X/simd_size()) __syncthreads();       \\\n"
"        if (bnum < active_subgs) {                                          \\\n"
"          if (eflag) {                                                      \\\n"
"            simd_reduce_add2(vwidth, energy, e_coul);                       \\\n"
"            if (voffset==0) {                                               \\\n"
"              red_acc[6][bnum] = energy;                                    \\\n"
"              red_acc[7][bnum] = e_coul;                                    \\\n"
"            }                                                               \\\n"
"          }                                                                 \\\n"
"          if (vflag) {                                                      \\\n"
"            simd_reduce_arr(6, vwidth, virial);                             \\\n"
"            if (voffset==0)                                                 \\\n"
"              for (int r=0; r<6; r++) red_acc[r][bnum]=virial[r];           \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"                                                                            \\\n"
"        __syncthreads();                                                    \\\n"
"        if (tid < active_subgs) {                                           \\\n"
"          if (eflag) {                                                      \\\n"
"            energy = red_acc[6][tid];                                       \\\n"
"            e_coul = red_acc[7][tid];                                       \\\n"
"          }                                                                 \\\n"
"          if (vflag)                                                        \\\n"
"            for (int r = 0; r < 6; r++) virial[r] = red_acc[r][tid];        \\\n"
"        } else {                                                            \\\n"
"          if (eflag) energy = e_coul = (acctyp)0;                           \\\n"
"          if (vflag) for (int r = 0; r < 6; r++) virial[r] = (acctyp)0;     \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"                                                                            \\\n"
"      if (bnum == 0) {                                                      \\\n"
"        int ei=BLOCK_ID_X;                                                  \\\n"
"        const int ev_stride=NUM_BLOCKS_X;                                   \\\n"
"        if (eflag) {                                                        \\\n"
"          simd_reduce_add2(vwidth, energy, e_coul);                         \\\n"
"          if (tid==0) {                                                     \\\n"
"            engv[ei]=energy*(acctyp)0.5;                                    \\\n"
"            ei+=ev_stride;                                                  \\\n"
"            engv[ei]=e_coul*(acctyp)0.5;                                    \\\n"
"            ei+=ev_stride;                                                  \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"        if (vflag) {                                                        \\\n"
"          simd_reduce_arr(6, vwidth, virial);                               \\\n"
"          if (tid==0) {                                                     \\\n"
"            for (int r=0; r<6; r++) {                                       \\\n"
"              engv[ei]=virial[r]*(acctyp)0.5;                               \\\n"
"              ei+=ev_stride;                                                \\\n"
"            }                                                               \\\n"
"          }                                                                 \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    } else if (offset==0 && ii<inum) {                                      \\\n"
"      int ei=ii;                                                            \\\n"
"      if (eflag) {                                                          \\\n"
"        engv[ei]=energy*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"        engv[ei]=e_coul*(acctyp)0.5;                                        \\\n"
"        ei+=inum;                                                           \\\n"
"      }                                                                     \\\n"
"      if (vflag) {                                                          \\\n"
"        for (int i=0; i<6; i++) {                                           \\\n"
"          engv[ei]=virial[i]*(acctyp)0.5;                                   \\\n"
"          ei+=inum;                                                         \\\n"
"        }                                                                   \\\n"
"      }                                                                     \\\n"
"    }                                                                       \\\n"
"  }\n"
"#else\n"
"#define local_allocate_store_pair()\n"
"#define local_allocate_store_charge()\n"
"#define local_allocate_store_bio()\n"
"#define local_allocate_store_ellipse()\n"
"#define local_allocate_store_three()\n"
"#define store_answers(f, energy, virial, ii, inum, tid,                     \\\n"
"                      t_per_atom, offset, eflag, vflag, ans, engv)          \\\n"
"  if (t_per_atom>1)                                                         \\\n"
"    simd_reduce_add3(t_per_atom, f.x, f.y, f.z);                            \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;\n"
"#define store_answers_q(f, energy, e_coul, virial, ii, inum, tid,           \\\n"
"                        t_per_atom, offset, eflag, vflag, ans, engv)        \\\n"
"  if (t_per_atom>1)                                                         \\\n"
"    simd_reduce_add3(t_per_atom, f.x, f.y, f.z);                            \\\n"
"  if (offset==0 && ii<inum) ans[ii]=f;\n"
"#endif\n"
"#endif\n"

"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"#include \"lal_preprocessor.h\"\n"
"#ifdef LAMMPS_SMALLBIG\n"
"#define tagint int\n"
"#endif\n"
"#ifdef LAMMPS_BIGBIG\n"
"#ifdef USE_OPENCL\n"
"#define tagint long\n"
"#else\n"
"#include \"stdint.h\"\n"
"#define tagint int64_t\n"
"#endif\n"
"#endif\n"
"#ifdef LAMMPS_SMALLSMALL\n"
"#define tagint int\n"
"#endif\n"
"#ifndef _DOUBLE_DOUBLE\n"
"_texture( pos_tex,float4);\n"
"#else\n"
"_texture_2d( pos_tex,int4);\n"
"#endif\n"
"#ifdef NV_KERNEL\n"
"#if (__CUDACC_VER_MAJOR__ == 11) && (__CUDACC_VER_MINOR__ >= 2)\n"
"#define LAL_USE_OLD_NEIGHBOR\n"
"#endif\n"
"#endif\n"
"#ifdef USE_HIP\n"
"#define LAL_USE_OLD_NEIGHBOR\n"
"#endif\n"
"__kernel void calc_cell_id(const numtyp4 *restrict x_,\n"
"                           unsigned *restrict cell_id,\n"
"                           int *restrict particle_id,\n"
"                           numtyp boxlo0, numtyp boxlo1, numtyp boxlo2,\n"
"                           numtyp i_cell_size, int ncellx, int ncelly,\n"
"                           int ncellz, int inum, int nall,\n"
"                           int cells_in_cutoff) {\n"
"  int i = threadIdx.x + blockIdx.x*blockDim.x;\n"
"  if (i < nall) {\n"
"    numtyp4 p;\n"
"    fetch4(p,i,pos_tex); \n"
"    p.x -= boxlo0;\n"
"    p.y -= boxlo1;\n"
"    p.z -= boxlo2;\n"
"    int ix = int(p.x*i_cell_size+cells_in_cutoff);\n"
"    int iy = int(p.y*i_cell_size+cells_in_cutoff);\n"
"    int iz = int(p.z*i_cell_size+cells_in_cutoff);\n"
"    int offset_lo, offset_hi;\n"
"    if (i<inum) {\n"
"      offset_lo=cells_in_cutoff;\n"
"      offset_hi=cells_in_cutoff+1;\n"
"    } else {\n"
"      offset_lo=0;\n"
"      offset_hi=1;\n"
"    }\n"
"    ix = max(ix,offset_lo);\n"
"    ix = min(ix,ncellx-offset_hi);\n"
"    iy = max(iy,offset_lo);\n"
"    iy = min(iy,ncelly-offset_hi);\n"
"    iz = max(iz,offset_lo);\n"
"    iz = min(iz,ncellz-offset_hi);\n"
"    cell_id[i] = ix+iy*ncellx+iz*ncellx*ncelly;\n"
"    particle_id[i] = i;\n"
"  }\n"
"}\n"
"__kernel void kernel_calc_cell_counts(const unsigned *restrict cell_id,\n"
"                                      int *restrict cell_counts,\n"
"                                      int nall, int ncell) {\n"
"  int idx = threadIdx.x + blockIdx.x * blockDim.x;\n"
"  if (idx < nall) {\n"
"    int id = cell_id[idx];\n"
"    \n"
"    if (idx == 0) {\n"
"      for (int i = 0; i < id + 1; i++)\n"
"        cell_counts[i] = 0;\n"
"    }\n"
"    if (idx == nall - 1) {\n"
"      for (int i = id+1; i <= ncell; i++)\n"
"        cell_counts[i] = nall;\n"
"    }\n"
"    if (idx > 0 && idx < nall) {\n"
"      int id_l = cell_id[idx-1];\n"
"      if (id != id_l) {\n"
"        for (int i = id_l+1; i <= id; i++)\n"
"          cell_counts[i] = idx;\n"
"      }\n"
"    }\n"
"  }\n"
"}\n"
"#else\n"
"#define pos_tex x_\n"
"#ifdef LAMMPS_SMALLBIG\n"
"#define tagint int\n"
"#endif\n"
"#ifdef LAMMPS_BIGBIG\n"
"#define tagint long\n"
"#endif\n"
"#ifdef LAMMPS_SMALLSMALL\n"
"#define tagint int\n"
"#endif\n"
"#endif\n"
"__kernel void transpose(__global tagint *restrict out,\n"
"                        const __global tagint *restrict in,\n"
"                        int columns_in, int rows_in)\n"
"{\n"
"  __local tagint block[BLOCK_CELL_2D][BLOCK_CELL_2D+1];\n"
"  unsigned ti=THREAD_ID_X;\n"
"  unsigned tj=THREAD_ID_Y;\n"
"  unsigned bi=BLOCK_ID_X;\n"
"  unsigned bj=BLOCK_ID_Y;\n"
"  unsigned i=bi*BLOCK_CELL_2D+ti;\n"
"  unsigned j=bj*BLOCK_CELL_2D+tj;\n"
"  if ((i<columns_in) && (j<rows_in))\n"
"    block[tj][ti]=in[j*columns_in+i];\n"
"   __syncthreads();\n"
"  i=bj*BLOCK_CELL_2D+ti;\n"
"  j=bi*BLOCK_CELL_2D+tj;\n"
"  if ((i<rows_in) && (j<columns_in))\n"
"    out[j*rows_in+i] = block[ti][tj];\n"
"}\n"
"#ifndef LAL_USE_OLD_NEIGHBOR\n"
"#define MAX_STENCIL_SIZE 25\n"
"#if !defined(MAX_SUBGROUPS_PER_BLOCK)\n"
"#define MAX_SUBGROUPS_PER_BLOCK 8\n"
"#endif\n"
"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"__device__ __constant__  int bin_stencil[MAX_STENCIL_SIZE];\n"
"#endif\n"
"__kernel void calc_neigh_list_cell(const __global numtyp4 *restrict x_,\n"
"                            const __global int *restrict cell_particle_id,\n"
"                            const __global int *restrict cell_counts,\n"
"                            __global int *nbor_list,\n"
"                            __global int *host_nbor_list,\n"
"                            __global int *host_numj,\n"
"                            int neigh_bin_size, numtyp cutoff_neigh,\n"
"                            int ncellx, int ncelly, int ncellz,\n"
"                            int inum, int nt, int nall, int t_per_atom,\n"
"                            int cells_in_cutoff,\n"
"                            const __global int *restrict cell_subgroup_counts,\n"
"                            const __global int *restrict subgroup2cell,\n"
"                            int subgroup_count,\n"
"#if defined(NV_KERNEL) || defined(USE_HIP)\n"
"                            int *not_used, __global int *error_flag)\n"
"#else\n"
"                            __constant int *bin_stencil,\n"
"                            __global int *error_flag)\n"
"#endif\n"
"{\n"
"  int tid = THREAD_ID_X;\n"
"  int bsx = BLOCK_SIZE_X;\n"
"  int simd_size = simd_size();\n"
"  int subgroup_id_local = tid / simd_size;\n"
"  int subgroup_id_global = BLOCK_ID_X * bsx / simd_size + subgroup_id_local;\n"
"  int lane_id = tid % simd_size;\n"
"#if (SHUFFLE_AVAIL == 0)\n"
"  __local int cell_list_sh[BLOCK_NBOR_BUILD];\n"
"  __local numtyp4 pos_sh[BLOCK_NBOR_BUILD];\n"
"  __local int local_cell_counts[BLOCK_NBOR_BUILD];\n"
"#endif\n"
"  __local int local_begin[(MAX_STENCIL_SIZE+1)*MAX_SUBGROUPS_PER_BLOCK];\n"
"  __local int local_counts[(MAX_STENCIL_SIZE+1)*MAX_SUBGROUPS_PER_BLOCK];\n"
"  if (subgroup_id_global < subgroup_count) {\n"
"    \n"
"    int icell = subgroup2cell[subgroup_id_global];\n"
"    int icell_end = cell_counts[icell+1];\n"
"    int i = cell_counts[icell] + (subgroup_id_global -\n"
"                                  cell_subgroup_counts[icell]) *\n"
"      simd_size + lane_id;\n"
"    \n"
"    const int bin_stencil_stride = cells_in_cutoff * 2 + 1;\n"
"    const int bin_stencil_size = bin_stencil_stride * bin_stencil_stride;\n"
"    int offset = 0;\n"
"    int cell_count = 0, jcellyz, jcell_begin;\n"
"    const int offset2 = subgroup_id_local * (MAX_STENCIL_SIZE+1);\n"
"    const int niter = (bin_stencil_size - 1)/simd_size + 1;\n"
"    int end_idx = simd_size;\n"
"    for (int ni = 0; ni < niter; ni++) {\n"
"      if (ni == niter - 1)\n"
"        end_idx = bin_stencil_size - offset;\n"
"      if (lane_id < end_idx) {\n"
"        jcellyz = icell + bin_stencil[lane_id + offset];\n"
"        jcell_begin = cell_counts[jcellyz - cells_in_cutoff];\n"
"        local_begin[lane_id + offset2 + offset] = jcell_begin;\n"
"            const int local_count = cell_counts[jcellyz + cells_in_cutoff + 1] -\n"
"                                    jcell_begin;\n"
"            cell_count += local_count;\n"
"        local_counts[lane_id + offset2 + offset] = local_count;\n"
"      }\n"
"      offset += simd_size;\n"
"    }\n"
"#if (SHUFFLE_AVAIL == 0)\n"
"    local_cell_counts[tid] = cell_count;\n"
"    offset = subgroup_id_local * simd_size;\n"
"    for (unsigned int mask=simd_size/2; mask>0; mask>>=1) {\n"
"      simdsync();\n"
"      local_cell_counts[tid] += local_cell_counts[ offset + lane_id^mask ];\n"
"    }\n"
"    simdsync();\n"
"    cell_count = local_cell_counts[tid];\n"
"#else\n"
"    #pragma unroll\n"
"    for (unsigned int s=simd_size/2; s>0; s>>=1)\n"
"      cell_count += shfl_xor(cell_count, s, simd_size);\n"
"#endif\n"
"    int num_iter = cell_count;\n"
"    int remainder = num_iter % simd_size;\n"
"    if (remainder == 0) remainder = simd_size;\n"
"    if (num_iter) num_iter = (num_iter - 1) / simd_size + 1;\n"
"    numtyp4 diff;\n"
"    numtyp r2;\n"
"    int pid_i = nall, lpid_j, stride;\n"
"    numtyp4 atom_i, atom_j;\n"
"    int cnt = 0;\n"
"    __global int *neigh_counts, *neigh_list;\n"
"    if (i < icell_end)\n"
"      pid_i = cell_particle_id[i];\n"
"    if (pid_i < nt) {\n"
"      fetch4(atom_i,pid_i,pos_tex); \n"
"    }\n"
"    if (pid_i < inum) {\n"
"      stride=inum;\n"
"      neigh_counts=nbor_list+stride+pid_i;\n"
"      neigh_list=neigh_counts+stride+pid_i*(t_per_atom-1);\n"
"      stride=stride*t_per_atom-t_per_atom;\n"
"      nbor_list[pid_i]=pid_i;\n"
"    } else {\n"
"      stride=0;\n"
"      neigh_counts=host_numj+pid_i-inum;\n"
"      neigh_list=host_nbor_list+(pid_i-inum)*neigh_bin_size;\n"
"    }\n"
"    \n"
"    int bin_shift = 0;\n"
"    int zy = -1;\n"
"    int num_atom_cell = 0;\n"
"    int cell_pos = lane_id;\n"
"    end_idx = simd_size;\n"
"    for (int ci = 0; ci < num_iter; ci++) {\n"
"      cell_pos += simd_size;\n"
"      while (cell_pos >= num_atom_cell && zy < bin_stencil_size) {\n"
"        \n"
"        bin_shift += num_atom_cell % simd_size;\n"
"        if (bin_shift >= simd_size) bin_shift -= simd_size;\n"
"        cell_pos = lane_id - bin_shift;\n"
"        if (cell_pos < 0) cell_pos += simd_size;\n"
"        \n"
"        zy++;\n"
"        jcell_begin = local_begin[offset2 + zy];\n"
"        num_atom_cell = local_counts[offset2 + zy];\n"
"      }\n"
"      if (zy < bin_stencil_size) {\n"
"        lpid_j =  cell_particle_id[jcell_begin + cell_pos];\n"
"        fetch4(atom_j,lpid_j,pos_tex);\n"
"#if (SHUFFLE_AVAIL == 0)\n"
"        cell_list_sh[tid] = lpid_j;\n"
"        pos_sh[tid].x = atom_j.x;\n"
"        pos_sh[tid].y = atom_j.y;\n"
"        pos_sh[tid].z = atom_j.z;\n"
"      }\n"
"      simdsync();\n"
"#else\n"
"      }\n"
"#endif\n"
"      if (ci == num_iter-1) end_idx = remainder;\n"
"      for (int j = 0; j < end_idx; j++) {\n"
"#if (SHUFFLE_AVAIL == 0)\n"
"        int pid_j = cell_list_sh[offset+j]; \n"
"        diff.x = atom_i.x - pos_sh[offset+j].x;\n"
"        diff.y = atom_i.y - pos_sh[offset+j].y;\n"
"        diff.z = atom_i.z - pos_sh[offset+j].z;\n"
"#else\n"
"        int pid_j = simd_broadcast_i(lpid_j, j, simd_size);\n"
"#ifdef _DOUBLE_DOUBLE\n"
"        diff.x = atom_i.x - simd_broadcast_d(atom_j.x, j, simd_size);\n"
"        diff.y = atom_i.y - simd_broadcast_d(atom_j.y, j, simd_size);\n"
"        diff.z = atom_i.z - simd_broadcast_d(atom_j.z, j, simd_size);\n"
"#else\n"
"        diff.x = atom_i.x - simd_broadcast_f(atom_j.x, j, simd_size);\n"
"        diff.y = atom_i.y - simd_broadcast_f(atom_j.y, j, simd_size);\n"
"        diff.z = atom_i.z - simd_broadcast_f(atom_j.z, j, simd_size);\n"
"#endif\n"
"#endif\n"
"        r2 = diff.x*diff.x + diff.y*diff.y + diff.z*diff.z;\n"
"        if (r2 < cutoff_neigh*cutoff_neigh && pid_j != pid_i && pid_i < nt) {\n"
"          if (cnt < neigh_bin_size) {\n"
"            cnt++;\n"
"            *neigh_list = pid_j;\n"
"            neigh_list++;\n"
"            if ((cnt & (t_per_atom-1))==0)\n"
"              neigh_list=neigh_list+stride;\n"
"          } else\n"
"            *error_flag=1;\n"
"        }\n"
"      } \n"
"#if (SHUFFLE_AVAIL == 0)\n"
"      simdsync();\n"
"#endif\n"
"    } \n"
"    if (pid_i < nt)\n"
"      *neigh_counts = cnt;\n"
"  } \n"
"}\n"
"#else\n"
"__kernel void calc_neigh_list_cell(const __global numtyp4 *restrict x_,\n"
"                                const __global int *restrict cell_particle_id,\n"
"                                const __global int *restrict cell_counts,\n"
"                                __global int *nbor_list,\n"
"                                __global int *host_nbor_list,\n"
"                                __global int *host_numj,\n"
"                                int neigh_bin_size, numtyp cell_size,\n"
"                                int ncellx, int ncelly, int ncellz,\n"
"                                int inum, int nt, int nall, int t_per_atom,\n"
"                                int cells_in_cutoff)\n"
"{\n"
"  int tid = THREAD_ID_X;\n"
"  int ix = BLOCK_ID_X + cells_in_cutoff;\n"
"  int iy = BLOCK_ID_Y % (ncelly - cells_in_cutoff*2) + cells_in_cutoff;\n"
"  int iz = BLOCK_ID_Y / (ncelly - cells_in_cutoff*2) + cells_in_cutoff;\n"
"  int bsx = BLOCK_SIZE_X;\n"
"  int icell = ix + iy*ncellx + iz*ncellx*ncelly;\n"
"  __local int cell_list_sh[BLOCK_NBOR_BUILD];\n"
"  __local numtyp4 pos_sh[BLOCK_NBOR_BUILD];\n"
"  int icell_begin = cell_counts[icell];\n"
"  int icell_end = cell_counts[icell+1];\n"
"  int nborz0 = iz-cells_in_cutoff, nborz1 = iz+cells_in_cutoff,\n"
"      nbory0 = iy-cells_in_cutoff, nbory1 = iy+cells_in_cutoff,\n"
"      nborx0 = ix-cells_in_cutoff, nborx1 = ix+cells_in_cutoff;\n"
"  numtyp4 diff;\n"
"  numtyp r2;\n"
"  int cap=ucl_ceil((numtyp)(icell_end - icell_begin)/bsx);\n"
"  for (int ii = 0; ii < cap; ii++) {\n"
"    int i = icell_begin + tid + ii*bsx;\n"
"    int pid_i = nall, pid_j, stride;\n"
"    numtyp4 atom_i, atom_j;\n"
"    int cnt = 0;\n"
"    __global int *neigh_counts, *neigh_list;\n"
"    if (i < icell_end)\n"
"      pid_i = cell_particle_id[i];\n"
"    if (pid_i < nt) {\n"
"      fetch4(atom_i,pid_i,pos_tex); \n"
"    }\n"
"    if (pid_i < inum) {\n"
"      stride=inum;\n"
"      neigh_counts=nbor_list+stride+pid_i;\n"
"      neigh_list=neigh_counts+stride+pid_i*(t_per_atom-1);\n"
"      stride=stride*t_per_atom-t_per_atom;\n"
"      nbor_list[pid_i]=pid_i;\n"
"    } else {\n"
"      stride=0;\n"
"      neigh_counts=host_numj+pid_i-inum;\n"
"      neigh_list=host_nbor_list+(pid_i-inum)*neigh_bin_size;\n"
"    }\n"
"    \n"
"    for (int nborz = nborz0; nborz <= nborz1; nborz++) {\n"
"      for (int nbory = nbory0; nbory <= nbory1; nbory++) {\n"
"        for (int nborx = nborx0; nborx <= nborx1; nborx++) {\n"
"          int jcell = nborx + nbory*ncellx + nborz*ncellx*ncelly;\n"
"          int jcell_begin = cell_counts[jcell];\n"
"          int jcell_end = cell_counts[jcell+1];\n"
"          int num_atom_cell = jcell_end - jcell_begin;\n"
"          \n"
"          int num_iter = ucl_ceil((numtyp)num_atom_cell/bsx);\n"
"          for (int k = 0; k < num_iter; k++) {\n"
"            int end_idx = min(bsx, num_atom_cell-k*bsx);\n"
"            if (tid < end_idx) {\n"
"              pid_j =  cell_particle_id[tid+k*bsx+jcell_begin];\n"
"              cell_list_sh[tid] = pid_j;\n"
"              fetch4(atom_j,pid_j,pos_tex); \n"
"              pos_sh[tid].x = atom_j.x;\n"
"              pos_sh[tid].y = atom_j.y;\n"
"              pos_sh[tid].z = atom_j.z;\n"
"            }\n"
"            __syncthreads();\n"
"            if (pid_i < nt) {\n"
"              for (int j = 0; j < end_idx; j++) {\n"
"                int pid_j = cell_list_sh[j]; \n"
"                diff.x = atom_i.x - pos_sh[j].x;\n"
"                diff.y = atom_i.y - pos_sh[j].y;\n"
"                diff.z = atom_i.z - pos_sh[j].z;\n"
"                r2 = diff.x*diff.x + diff.y*diff.y + diff.z*diff.z;\n"
"                if (r2 < cell_size*cell_size && pid_j != pid_i) {\n"
"                  cnt++;\n"
"                  if (cnt <= neigh_bin_size) {\n"
"                    *neigh_list = pid_j;\n"
"                    neigh_list++;\n"
"                    if ((cnt & (t_per_atom-1))==0)\n"
"                      neigh_list=neigh_list+stride;\n"
"                  }\n"
"                }\n"
"              }\n"
"            }\n"
"            __syncthreads();\n"
"          } \n"
"        }\n"
"      }\n"
"    }\n"
"    if (pid_i < nt)\n"
"      *neigh_counts = cnt;\n"
"  } \n"
"}\n"
"#endif\n"
"__kernel void kernel_special(__global int *dev_nbor,\n"
"                             __global int *host_nbor_list,\n"
"                             const __global int *host_numj,\n"
"                             const __global tagint *restrict tag,\n"
"                             const __global int *restrict nspecial,\n"
"                             const __global tagint *restrict special,\n"
"                             int inum, int nt, int max_nbors, int t_per_atom) {\n"
"  int tid=THREAD_ID_X;\n"
"  int ii=fast_mul((int)BLOCK_ID_X,(int)(BLOCK_SIZE_X)/t_per_atom);\n"
"  ii+=tid/t_per_atom;\n"
"  int offset=tid & (t_per_atom-1);\n"
"  if (ii<nt) {\n"
"    int stride;\n"
"    __global int *list, *list_end;\n"
"    int n1=nspecial[ii*3];\n"
"    int n2=nspecial[ii*3+1];\n"
"    int n3=nspecial[ii*3+2];\n"
"    int numj;\n"
"    if (ii < inum) {\n"
"      stride=inum;\n"
"      list=dev_nbor+stride+ii;\n"
"      numj=*list;\n"
"      list+=stride+fast_mul(ii,t_per_atom-1);\n"
"      stride=fast_mul(inum,t_per_atom);\n"
"      int njt=numj/t_per_atom;\n"
"      list_end=list+fast_mul(njt,stride)+(numj & (t_per_atom-1));\n"
"      list+=offset;\n"
"    } else {\n"
"      stride=1;\n"
"      list=host_nbor_list+(ii-inum)*max_nbors;\n"
"      numj=host_numj[ii-inum];\n"
"      list_end=list+fast_mul(numj,stride);\n"
"    }\n"
"    for ( ; list<list_end; list+=stride) {\n"
"      int nbor=*list;\n"
"      tagint jtag=tag[nbor];\n"
"      int offset=ii;\n"
"      for (int i=0; i<n3; i++) {\n"
"        if (special[offset]==jtag) {\n"
"          int which = 1;\n"
"          if (i>=n1)\n"
"            which++;\n"
"          if (i>=n2)\n"
"            which++;\n"
"          nbor=nbor ^ (which << SBBITS);\n"
"          *list=nbor;\n"
"        }\n"
"        offset+=nt;\n"
"      }\n"
"    }\n"
"  } \n"
"}\n"
;
